from gi.repository import Nautilus, GObject
import os
import subprocess
import urllib

class CrunchyCompress(GObject.GObject, Nautilus.MenuProvider):
    def __init__(self):
        pass

    def url2path(self,url):
        fileuri= url.get_activation_uri()
        arg_uri=fileuri[7:]
        path=urllib.url2pathname(arg_uri)
        return path

    def compress(self,menu,files):
        cmd=['crunchy-gtk','--create']
        return self.execute_for_all(menu,cmd,files)

    def execute_for_all(self,menu,cmd,files):
        for file in files:
            filepath=self.url2path(file)
            cmd.append(filepath)
        return subprocess.Popen(cmd)
    
    def isdir(self,files):
        isdir=False
        for file in files:
            mime= file.get_mime_type()
            if mime =='inode/directory':
                isdir=True
            else:
                isdir=False
        return isdir

    def isfile(self,files):
        isfile=False
        for file in files:
            mime= file.get_mime_type()
            if mime !='inode/directory':
                isfile=True
            else:
                isfile=False
        return isfile
    
    def get_file_items(self, window, files):
        filecount=len(files)
        if filecount <= 0:
            return 

        # compress
        menu_item = Nautilus.MenuItem(name='CrunchyCompressMenuItem::CrunchyCompress', 
                                        label='Compress...', 
                                        tip='Compress selected files and folders',
                                        )

        menu_item.connect('activate',self.compress,files)
        
        return [menu_item]
