from gi.repository import Nautilus, GObject
import os
import subprocess
import urllib

class CrunchyExtractHere(GObject.GObject, Nautilus.MenuProvider):
    def __init__(self):
        pass

    def url2path(self,url):
        fileuri= url.get_activation_uri()
        arg_uri=fileuri[7:]
        path=urllib.url2pathname(arg_uri)
        return path

    def extract_here(self,menu,files):
        for file in files:
            cmd=['crunchy-gtk','--extract-same']
            filepath=self.url2path(file)
            cmd.append(filepath)
            proc = subprocess.Popen(cmd)
            proc.wait()
        return

    def is_files(self,files):
        for file in files:
            mime=file.get_mime_type()
            if mime == 'inode/directory':
                return False
        return True
    
    def get_file_items(self, window, files):
        filecount=len(files)
        if filecount <= 0:
            return 

        if self.is_files(files) == True :
            # extract to folder
            menu_item = Nautilus.MenuItem(name='CrunchyExtractHereMenuItem::CrunchyExtractHere', 
                                        label='Extract Here', 
                                        tip='Extract files to subfolder'
                                        )
            menu_item.connect('activate',self.extract_here,files)
            return [menu_item]
        else:
            return
        
