from gi.repository import Nautilus, GObject
import os
import subprocess
import urllib

class Crunchy(GObject.GObject, Nautilus.MenuProvider):
    def __init__(self):
        pass

    def url2path(self,url):
        fileuri= url.get_activation_uri()
        arg_uri=fileuri[7:]
        path=urllib.url2pathname(arg_uri)
        return path
    
    def compress(self,menu,files):
        cmd=['crunchy-gtk','--create']
        return self.execute_for_all(menu,cmd,files)
    
    def test(self,menu,files):
        cmd=['crunchy-gtk','--test']
        return self.execute_for_first(menu,cmd,files)
    
    def extract_here(self,menu,files):
        for file in files:
            cmd=['crunchy-gtk','--extract-same']
            filepath=self.url2path(file)
            cmd.append(filepath)
            proc = subprocess.Popen(cmd)
            proc.wait()
        return
    
    def extract_to(self,menu,files):
        for file in files:
            cmd=['crunchy-gtk']
            filepath=self.url2path(files[0])
            cmd.append("--extract-to")
            cmd.append(filepath)
            subprocess.Popen(cmd)
            break
        return

    def execute_for_all(self,menu,cmd,files):
        for file in files:
            filepath=self.url2path(file)
            cmd.append(filepath)
        return subprocess.Popen(cmd)
    
    def execute_for_first(self,menu,cmd,files):
        for file in files:
            filepath=self.url2path(file)
            cmd.append(filepath)
            break;
        return subprocess.Popen(cmd)

    def execute_for_each(self,menu,cmd,files):
        for file in files:
            filepath=self.url2path(file)
            cmd.append(filepath)
            subprocess.Popen(cmd)
        return subprocess.Popen(cmd)
    
    def is_files(self,files):
        for file in files:
            mime=file.get_mime_type()
            if mime == 'inode/directory':
                return False
        return True
    
    def get_file_items(self, window, files):
        filecount=len(files)
        if filecount <= 0:
            return 

        top_menu = Nautilus.MenuItem(name='CrunchySubMenu::Crunchy', 
                                        label='Crunchy', 
                                        tip='',
                                        )
        
        sub_menu = Nautilus.Menu()
        top_menu.set_submenu(sub_menu)
        
        # compress
        menu_item = Nautilus.MenuItem(name='CrunchyMenuItem::CrunchyCompress', 
                                        label='Compress...', 
                                        tip='Compress selected files and folders'
                                        )
        sub_menu.append_item(menu_item)
        menu_item.connect('activate',self.compress,files)

		if is_files(files) == True:
			
            # extract here
            menu_item = Nautilus.MenuItem(name='CrunchyMenuItem::CrunchyExtractHere', 
                                        label='Extract Here', 
                                        tip='Extract files to subfolder'
                                        )
            sub_menu.append_item(menu_item)
            menu_item.connect('activate',self.extract_here,files)
        
            # extract to
            menu_item = Nautilus.MenuItem(name='CrunchyMenuItem::CrunchyExtractTo', 
                                        label='Extract To...', 
                                        tip='Extract files in archive to specified location'
                                        )
            sub_menu.append_item(menu_item)
            menu_item.connect('activate',self.extract_to,files)
		
        return [top_menu]
